unit frmosciloscopio;

interface
uses
        Windows,
        Messages,
        SysUtils,
        Classes,
        Graphics,
        Controls,
        Forms,
        Dialogs,
        TeEngine,
        Series,
        ExtCtrls,
        TeeProcs,
        Chart,
        StdCtrls;


type
        Tfrm_osciloscopio = class(TForm)
        grafico: TChart;
        Series1: TLineSeries;
        GroupBox1: TGroupBox;
        GroupBox2: TGroupBox;
        bt_leitura: TButton;
        Label1: TLabel;
        Label2: TLabel;
        Label3: TLabel;
        tx_intervalo: TEdit;
        tx_porta_dados: TEdit;
        tx_porta_status: TEdit;
        bt_sobre: TButton;
        bt_sair: TButton;
        temporizador: TTimer;
        cx_eixos: TCheckBox;
        Label4: TLabel;
        tx_horizontal: TEdit;
        cx_inverte: TCheckBox;

        procedure bt_sairClick(Sender: TObject);
        procedure cx_eixosClick(Sender: TObject);
        procedure bt_leituraClick(Sender: TObject);
        procedure temporizadorTimer(Sender: TObject);
        procedure bt_sobreClick(Sender: TObject);
        procedure cx_inverteClick(Sender: TObject);
//      procedure EscrevePorta(porta, dados:word);
//      function LePorta(porta: word): word;


private

public

end;

var
        frm_osciloscopio: Tfrm_osciloscopio;
        porta_dados:word;
        porta_status:word;
        horizontal:integer;
        numero_leituras:integer;



implementation
uses frmsobre;
{$R *.DFM}

procedure EscrevePorta(porta:word; dados:word);
        begin
        asm
                Mov ax,dados
                Mov dx,porta
                Out dx,ax
                end;
        end;

function LePorta(porta:word):integer;
        var
                dados:word;
        begin
        asm
                Mov dx,porta
                In ax,dx
                Mov dados,ax
                end;
        LePorta := Byte(dados);
        end;

procedure Tfrm_osciloscopio.bt_sairClick(Sender: TObject);
        begin
        application.terminate;
        end;

procedure Tfrm_osciloscopio.cx_eixosClick(Sender: TObject);
        begin
        grafico.AxisVisible := cx_eixos.checked;
        end;

procedure Tfrm_osciloscopio.bt_leituraClick(Sender: TObject);
        var
                intervalo:integer;
                erro_intervalo:integer;
                erro_porta_dados:integer;
                erro_porta_status:integer;
                erro_horizontal:integer;
        begin
                val(tx_intervalo.text, intervalo, erro_intervalo);
                val(tx_horizontal.text, horizontal, erro_horizontal);
                val(tx_porta_dados.text, porta_dados, erro_porta_dados);
                val(tx_porta_status.text, porta_status, erro_porta_status);

                if erro_intervalo <> 0 then
                        application.messagebox(' Intervalo de leitura invlido.', 'ERRO',MB_OK);

                if erro_horizontal <> 0 then
                        application.messagebox(' Escala horizontal invlida.', 'ERRO',MB_OK);

                if erro_porta_dados <> 0 then
                        application.messagebox('Porta de dados invlida! O uso de uma porta incorreta pode causar efeitos desconhecidos sobre o hardware.', 'ERRO',MB_OK);

                if erro_porta_status <> 0 then
                        application.messagebox('Porta de status invlida! O uso de uma porta incorreta pode causar efeitos desconhecidos sobre o hardware.', 'ERRO',MB_OK);

                if (erro_intervalo = 0) and (erro_horizontal = 0) and (erro_porta_dados = 0) and (erro_porta_status = 0) then
                        begin
                        if temporizador.enabled = false then
                                begin
                                tx_intervalo.enabled := false;
                                tx_horizontal.enabled := false;
                                tx_porta_dados.enabled := false;
                                tx_porta_status.enabled := false;
                                temporizador.interval := intervalo;
                                bt_leitura.caption := '&Finalizar Leitura';
                                temporizador.enabled := true;
                                end
                        else
                                begin
                                temporizador.enabled := false;
                                tx_intervalo.enabled := true;
                                tx_horizontal.enabled := true;
                                tx_porta_dados.enabled := true;
                                tx_porta_status.enabled := true;
                                bt_leitura.caption := 'Iniciar &Leitura';
                                end;
                       end;
        end;

procedure Tfrm_osciloscopio.temporizadorTimer(Sender: TObject);
        var
                str_num_leituras:string;
        begin
                temporizador.enabled := false;

                numero_leituras := numero_leituras + 1;
                if numero_leituras > 60000 then
                        numero_leituras := 0;

                str(numero_leituras, str_num_leituras);
                grafico.Foot.Text.Clear;
                grafico.Foot.Text.Add('Escrevendo: ' + tx_porta_dados.text + ' / Lendo: ' + tx_porta_status.text + ' / ' + str_num_leituras + ' Leituras');

                grafico.bottomAxis.minimum := numero_leituras - horizontal;
                grafico.BottomAxis.maximum := numero_leituras;

                escreveporta(porta_dados, 128);
                if (leporta(porta_status) and 128) = 128 then
                        grafico.series[0].add(10,'',)
                else
                        grafico.series[0].add(0,'',);

                temporizador.enabled := true;
        end;

procedure Tfrm_osciloscopio.bt_sobreClick(Sender: TObject);
        begin
        frm_sobre.show;
        end;

procedure Tfrm_osciloscopio.cx_inverteClick(Sender: TObject);
        begin
        grafico.LeftAxis.Inverted := cx_inverte.checked;
        end;

end.
